Index: palm/trunk/SOURCE/lpm_droplet_collision.f90
===================================================================
--- palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1822)
@@ -303,392 +319,197 @@
           ENDIF
 
-          particles(psi:pse)%radius = rad(1:prt_count(k,j,i))
-          particles(psi:pse)%weight_factor = weight(1:prt_count(k,j,i))
-
-          DEALLOCATE(rad, weight)
-
-       ELSEIF ( ( hall_kernel  .OR.  wang_kernel )  .AND.  &
-                .NOT. use_kernel_tables )  THEN
-!
-!--       Collision efficiencies are calculated for every new
+          particles(1:number_of_particles)%radius = ( mass(1:number_of_particles) /   &
+                                                      ( weight(1:number_of_particles) &
+                                                        * factor_volume_to_mass       &
+                                                      )                               &
+                                                    )**0.33333333333333_wp
+
+          particles(1:number_of_particles)%weight_factor = weight(1:number_of_particles)
+
+          DEALLOCATE(weight, mass)
+
+       ELSEIF ( .NOT. use_kernel_tables )  THEN
+!
+!--       Collection kernels are calculated for every new
 !--       grid box. First, allocate memory for kernel table.
 !--       Third dimension is 1, because table is re-calculated for
 !--       every new dissipation value.
-          ALLOCATE( ckernel(1:prt_count(k,j,i),1:prt_count(k,j,i),1:1) )
-!
-!--       Now calculate collision efficiencies for this box
+          ALLOCATE( ckernel(1:number_of_particles,1:number_of_particles,1:1) )
+!
+!--       Now calculate collection kernel for this box. Note that
+!--       the kernel is based on the previous time step
           CALL recalculate_kernel( i, j, k )
-
 !
 !--       Droplet collision are calculated using collision-coalescence
 !--       formulation proposed by Wang (see PALM documentation)
-!--       Since new radii after collision are defined by radii of all
-!--       droplets before collision, temporary fields for new radii and
-!--       weighting factors are needed
-          ALLOCATE(rad(1:prt_count(k,j,i)), weight(1:prt_count(k,j,i)))
-
-          rad = 0.0_wp
-          weight = 0.0_wp
-
-          DO  n = psi, pse, 1
-
-             sum1 = 0.0_wp
-             sum2 = 0.0_wp
-             sum3 = 0.0_wp
-!
-!--          Mass added due to collisions with smaller droplets
-             DO  is = psi, n-1
-                sum1 = sum1 + ( particles(is)%radius**3 *            &
-                                ckernel(n,is,1) *  &
-                                particles(is)%weight_factor )
+!--       Temporary fields for total mass of super-droplet and weighting factors 
+!--       are allocated.
+          ALLOCATE(mass(1:number_of_particles), weight(1:number_of_particles))
+
+          mass(1:number_of_particles) = particles(1:number_of_particles)%weight_factor * &
+                                        particles(1:number_of_particles)%radius**3     * &
+                                        factor_volume_to_mass
+
+          weight(1:number_of_particles) = particles(1:number_of_particles)%weight_factor
+
+          IF ( average_impact )  THEN  ! select collision algorithm
+
+             DO  n = 1, number_of_particles
+
+                xn = mass(n) / weight(n) ! mean mass of droplet n
+
+                DO  m = n, number_of_particles
+
+                   xm = mass(m) / weight(m) !mean mass of droplet m
+
+                   IF ( xm .LT. xn )  THEN
+!
+!--                   Particle n collects smaller particle m 
+                      collection_probability = ckernel(n,m,1) * weight(n) *    &
+                                               ddV * dt_3d
+
+                      mass(n)   = mass(n)   + mass(m)   * collection_probability
+                      weight(m) = weight(m) - weight(m) * collection_probability
+                      mass(m)   = mass(m)   - mass(m)   * collection_probability
+                   ELSEIF ( xm .GT. xn )  THEN 
+!
+!--                   Particle m collects smaller particle n
+                      collection_probability = ckernel(n,m,1) * weight(m) *    &
+                                               ddV * dt_3d
+
+                      mass(m)   = mass(m)   + mass(n)   * collection_probability
+                      weight(n) = weight(n) - weight(n) * collection_probability
+                      mass(n)   = mass(n)   - mass(n)   * collection_probability
+                   ELSE
+!
+!--                   Same-size collections. If n = m, weight is reduced by the
+!--                   number of possible same-size collections; the total mass 
+!--                   mass is not changed during same-size collection. 
+!--                   Same-size collections of different 
+!--                   particles ( n /= m ) are treated as same-size collections 
+!--                   of ONE partilce with weight = weight(n) + weight(m) and 
+!--                   mass = mass(n) + mass(m).
+!--                   Accordingly, each particle loses the same number of 
+!--                   droplets to the other particle, but this has no effect on 
+!--                   total mass mass, since the exchanged droplets have the 
+!--                   same radius. 
+!--
+!--                   Note: For m = n this equation is an approximation only 
+!--                   valid for weight >> 1 (which is usually the case). The
+!--                   approximation is weight(n)-1 = weight(n).
+                      weight(n) = weight(n) - 0.5_wp * weight(n) *             &
+                                              ckernel(n,m,1) * weight(m) *     &
+                                              ddV * dt_3d
+                      IF ( n .NE. m )  THEN
+                         weight(m) = weight(m) - 0.5_wp * weight(m) *          &
+                                                 ckernel(n,m,1) * weight(n) *  &
+                                                 ddV * dt_3d
+                      ENDIF
+                   ENDIF
+
+
+                ENDDO
+
+                ql_vp(k,j,i) = ql_vp(k,j,i) + mass(n) / factor_volume_to_mass
+
              ENDDO
-!
-!--          Rate of collisions with larger droplets
-             DO  is = n+1, pse
-                sum2 = sum2 + ( ckernel(n,is,1) *  &
-                                particles(is)%weight_factor )
+
+          ELSEIF ( all_or_nothing )  THEN  ! select collision algorithm
+
+             DO  n = 1, number_of_particles
+
+                xn = mass(n) / weight(n) ! mean mass of droplet n
+
+                DO  m = n, number_of_particles
+
+                   xm = mass(m) / weight(m) !mean mass of droplet m
+
+                   IF ( weight(n) .LT. weight(m) )  THEN
+!
+!--                   Particle n collects smaller particle m 
+                      collection_probability = ckernel(n,m,1) * weight(m) *    &
+                                               ddV * dt_3d
+
+                      IF ( collection_probability .GT. random_function( iran_part ) )  THEN
+                         mass(n) = mass(n) + weight(n) * xm  
+                         weight(m)    = weight(m)    - weight(n)
+                         mass(m) = mass(m) - weight(n) * xm
+                      ENDIF
+
+                   ELSEIF ( weight(m) .LT. weight(n) )  THEN
+!
+!--                   Particle m collects smaller particle n
+                      collection_probability = ckernel(n,m,1) * weight(n) *    &
+                                               ddV * dt_3d
+
+                      IF ( collection_probability .GT. random_function( iran_part ) )  THEN
+                         mass(m) = mass(m) + weight(m) * xn
+                         weight(n)    = weight(n)    - weight(m)
+                         mass(n) = mass(n) - weight(m) * xn
+                      ENDIF
+                   ELSE
+!
+!--                   Collisions of particles of the same weighting factor. 
+!--                   Particle n collects 1/2 weight(n) droplets of particle m,
+!--                   particle m collects 1/2 weight(m) droplets of particle n.
+!--                   The total mass mass changes accordingly.
+!--                   If n = m, the first half of the droplets coalesces with the 
+!--                   second half of the droplets; mass is unchanged because
+!--                   xm = xn for n = m.
+!--
+!--                   Note: For m = n this equation is an approximation only 
+!--                   valid for weight >> 1 (which is usually the case). The
+!--                   approximation is weight(n)-1 = weight(n).
+                      collection_probability = ckernel(n,m,1) * weight(n) *    &
+                                               ddV * dt_3d
+
+                      IF ( collection_probability .GT. random_function( iran_part ) )  THEN
+                         mass(n)   = mass(n)   + 0.5_wp * weight(n) * ( xm - xn )
+                         mass(m)   = mass(m)   + 0.5_wp * weight(m) * ( xn - xm )
+                         weight(n) = weight(n) - 0.5_wp * weight(m)
+                         weight(m) = weight(n)
+                      ENDIF
+                   ENDIF
+
+
+                ENDDO
+
+                ql_vp(k,j,i) = ql_vp(k,j,i) + mass(n) / factor_volume_to_mass
+
              ENDDO
 
-             r3 = particles(n)%radius**3
-             ddV = ddx * ddy / dz 
-             is = 1
-!
-!--                   Change of the current weighting factor
-             sum3 = 1 - dt_3d * ddV *                                 &
-                        ckernel(n,n,1) *           &
-                        ( particles(n)%weight_factor - 1 ) * 0.5_wp - &
-                    dt_3d * ddV * sum2
-             weight(n-is+1) = particles(n)%weight_factor * sum3
-!
-!--                   Change of the current droplet radius
-             rad(n-is+1) = ( (r3 + dt_3d * ddV * (sum1 - sum2 * r3) )/&
-                              sum3 )**0.33333333333333_wp
-
-             IF ( weight(n-is+1) < 0.0_wp )  THEN
-                WRITE( message_string, * ) 'negative weighting',      &
-                                           'factor: ', weight(n-is+1)
-                CALL message( 'lpm_droplet_collision', 'PA0037',      &
+          ENDIF
+
+          IF ( ANY(weight < 0.0_wp) )  THEN
+                WRITE( message_string, * ) 'negative weighting'
+                CALL message( 'lpm_droplet_collision', 'PA0028',      &
                                2, 2, -1, 6, 1 )
-             ENDIF
-
-             ql_vp(k,j,i) = ql_vp(k,j,i) + weight(n-is+1) &
-                                         * rad(n-is+1)**3
-
-          ENDDO
-
-          particles(psi:pse)%radius = rad(1:prt_count(k,j,i))
-          particles(psi:pse)%weight_factor = weight(1:prt_count(k,j,i))
-
-          DEALLOCATE( rad, weight, ckernel )
-
-       ELSEIF ( palm_kernel )  THEN
-!
-!--       PALM collision kernel
-!
-!--       Calculate the mean radius of all those particles which
-!--       are of smaller size than the current particle and
-!--       use this radius for calculating the collision efficiency
-          DO  n = psi+prt_count(k,j,i)-1, psi+1, -1
-
-             sl_r3 = 0.0_wp
-             sl_r4 = 0.0_wp
-
-             DO is = n-1, psi, -1
-                IF ( particles(is)%radius < particles(n)%radius )  &
-                THEN
-                   sl_r3 = sl_r3 + particles(is)%weight_factor     &
-                                   * particles(is)%radius**3
-                   sl_r4 = sl_r4 + particles(is)%weight_factor     &
-                                   * particles(is)%radius**4
-                ENDIF
-             ENDDO
-
-             IF ( ( sl_r3 ) > 0.0_wp )  THEN
-                mean_r = ( sl_r4 ) / ( sl_r3 )
-
-                CALL collision_efficiency_rogers( mean_r,             &
-                                           particles(n)%radius,       &
-                                           effective_coll_efficiency )
-
-             ELSE
-                effective_coll_efficiency = 0.0_wp
-             ENDIF
-
-             IF ( effective_coll_efficiency > 1.0_wp  .OR.            &
-                  effective_coll_efficiency < 0.0_wp )                &
-             THEN
-                WRITE( message_string, * )  'collision_efficien' , &
-                          'cy out of range:' ,effective_coll_efficiency
-                CALL message( 'lpm_droplet_collision', 'PA0145', 2, &
-                              2, -1, 6, 1 )
-             ENDIF
-
-!
-!--          Interpolation of liquid water content
-             ii = particles(n)%x * ddx
-             jj = particles(n)%y * ddy
-             kk = ( particles(n)%z + 0.5_wp * dz ) / dz
-
-             x  = particles(n)%x - ii * dx
-             y  = particles(n)%y - jj * dy
-             aa = x**2          + y**2
-             bb = ( dx - x )**2 + y**2
-             cc = x**2          + ( dy - y )**2
-             dd = ( dx - x )**2 + ( dy - y )**2
-             gg = aa + bb + cc + dd
-
-             ql_int_l = ( (gg-aa) * ql(kk,jj,ii)   + (gg-bb) *     &
-                                                  ql(kk,jj,ii+1)   &
-                        + (gg-cc) * ql(kk,jj+1,ii) + ( gg-dd ) *   &
-                                                  ql(kk,jj+1,ii+1) &
-                        ) / ( 3.0_wp * gg )
-
-             ql_int_u = ( (gg-aa) * ql(kk+1,jj,ii)   + (gg-bb) *   &
-                                                ql(kk+1,jj,ii+1)   &
-                        + (gg-cc) * ql(kk+1,jj+1,ii) + (gg-dd) *   &
-                                                ql(kk+1,jj+1,ii+1) &
-                        ) / ( 3.0_wp * gg )
-
-             ql_int = ql_int_l + ( particles(n)%z - zu(kk) ) / dz *&
-                                 ( ql_int_u - ql_int_l )
-
-!
-!--          Interpolate u velocity-component
-             ii = ( particles(n)%x + 0.5_wp * dx ) * ddx
-             jj =   particles(n)%y * ddy
-             kk = ( particles(n)%z + 0.5_wp * dz ) / dz ! only if equidistant
-
-             IF ( ( particles(n)%z - zu(kk) ) > ( 0.5_wp * dz ) ) kk = kk+1
-
-             x  = particles(n)%x + ( 0.5_wp - ii ) * dx
-             y  = particles(n)%y - jj * dy
-             aa = x**2          + y**2
-             bb = ( dx - x )**2 + y**2
-             cc = x**2          + ( dy - y )**2
-             dd = ( dx - x )**2 + ( dy - y )**2
-             gg = aa + bb + cc + dd
-
-             u_int_l = ( (gg-aa) * u(kk,jj,ii)   + (gg-bb) *       &
-                                                  u(kk,jj,ii+1)    &
-                       + (gg-cc) * u(kk,jj+1,ii) + (gg-dd) *       &
-                                                  u(kk,jj+1,ii+1)  &
-                       ) / ( 3.0_wp * gg ) - u_gtrans
-             IF ( kk+1 == nzt+1 )  THEN
-                u_int = u_int_l
-             ELSE
-                u_int_u = ( (gg-aa) * u(kk+1,jj,ii)   + (gg-bb) *  &
-                                                 u(kk+1,jj,ii+1)   &
-                          + (gg-cc) * u(kk+1,jj+1,ii) + (gg-dd) *  &
-                                                 u(kk+1,jj+1,ii+1) &
-                          ) / ( 3.0_wp * gg ) - u_gtrans
-                u_int = u_int_l + ( particles(n)%z - zu(kk) ) / dz &
-                                  * ( u_int_u - u_int_l )
-             ENDIF
-
-!
-!--          Same procedure for interpolation of the v velocity-component 
-!--          (adopt index k from u velocity-component)
-             ii =   particles(n)%x * ddx
-             jj = ( particles(n)%y + 0.5_wp * dy ) * ddy
-
-             x  = particles(n)%x - ii * dx
-             y  = particles(n)%y + ( 0.5_wp - jj ) * dy
-             aa = x**2          + y**2
-             bb = ( dx - x )**2 + y**2
-             cc = x**2          + ( dy - y )**2
-             dd = ( dx - x )**2 + ( dy - y )**2
-             gg = aa + bb + cc + dd
-
-             v_int_l = ( ( gg-aa ) * v(kk,jj,ii)   + ( gg-bb ) *   &
-                                                   v(kk,jj,ii+1)   &
-                       + ( gg-cc ) * v(kk,jj+1,ii) + ( gg-dd ) *   &
-                                                   v(kk,jj+1,ii+1) &
-                       ) / ( 3.0_wp * gg ) - v_gtrans
-             IF ( kk+1 == nzt+1 )  THEN
-                v_int = v_int_l
-             ELSE
-                v_int_u = ( (gg-aa) * v(kk+1,jj,ii)   + (gg-bb) *  &
-                                                   v(kk+1,jj,ii+1) &
-                          + (gg-cc) * v(kk+1,jj+1,ii) + (gg-dd) *  &
-                                                 v(kk+1,jj+1,ii+1) &
-                          ) / ( 3.0_wp * gg ) - v_gtrans
-                v_int = v_int_l + ( particles(n)%z - zu(kk) ) / dz &
-                                  * ( v_int_u - v_int_l )
-             ENDIF
-
-!
-!--          Same procedure for interpolation of the w velocity-component 
-!--          (adopt index i from v velocity-component)
-             jj = particles(n)%y * ddy
-             kk = particles(n)%z / dz
-
-             x  = particles(n)%x - ii * dx
-             y  = particles(n)%y - jj * dy
-             aa = x**2          + y**2
-             bb = ( dx - x )**2 + y**2
-             cc = x**2          + ( dy - y )**2
-             dd = ( dx - x )**2 + ( dy - y )**2
-             gg = aa + bb + cc + dd
-
-             w_int_l = ( ( gg-aa ) * w(kk,jj,ii)   + ( gg-bb ) *   &
-                                                     w(kk,jj,ii+1) &
-                       + ( gg-cc ) * w(kk,jj+1,ii) + ( gg-dd ) *   &
-                                                   w(kk,jj+1,ii+1) &
-                       ) / ( 3.0_wp * gg )
-             IF ( kk+1 == nzt+1 )  THEN
-                w_int = w_int_l
-             ELSE
-                w_int_u = ( (gg-aa) * w(kk+1,jj,ii)   + (gg-bb) *  &
-                                                   w(kk+1,jj,ii+1) &
-                          + (gg-cc) * w(kk+1,jj+1,ii) + (gg-dd) *  &
-                                                 w(kk+1,jj+1,ii+1) &
-                          ) / ( 3.0_wp * gg )
-                w_int = w_int_l + ( particles(n)%z - zw(kk) ) / dz &
-                                  * ( w_int_u - w_int_l )
-             ENDIF
-
-!
-!--          Change in radius due to collision
-             delta_r = effective_coll_efficiency / 3.0_wp          &
-                       * pi * sl_r3 * ddx * ddy / dz               &
-                       * SQRT( ( u_int - particles(n)%speed_x )**2 &
-                             + ( v_int - particles(n)%speed_y )**2 &
-                             + ( w_int - particles(n)%speed_z )**2 &
-                             ) * dt_3d
-!
-!--          Change in volume due to collision
-             delta_v = particles(n)%weight_factor                  &
-                       * ( ( particles(n)%radius + delta_r )**3    &
-                           - particles(n)%radius**3 )
-
-!
-!--          Check if collected particles provide enough LWC for
-!--          volume change of collector particle
-             IF ( delta_v >= sl_r3  .AND.  sl_r3 > 0.0_wp )  THEN
-
-                delta_r = ( ( sl_r3/particles(n)%weight_factor )               &
-                            + particles(n)%radius**3 )**( 1.0_wp / 3.0_wp )    &
-                            - particles(n)%radius
-
-                DO  is = n-1, psi, -1
-                   IF ( particles(is)%radius < particles(n)%radius )  THEN
-                      particles(is)%weight_factor = 0.0_wp
-                      particles(is)%particle_mask = .FALSE.
-                      deleted_particles = deleted_particles + 1
-                   ENDIF
-                ENDDO
-
-             ELSE IF ( delta_v < sl_r3  .AND.  sl_r3 > 0.0_wp )  THEN
-
-                DO  is = n-1, psi, -1
-                   IF ( particles(is)%radius < particles(n)%radius &
-                        .AND.  sl_r3 > 0.0_wp )  THEN
-                      particles(is)%weight_factor =                &
-                                   ( ( particles(is)%weight_factor &
-                                   * ( particles(is)%radius**3 ) ) &
-                                   - ( delta_v                     &
-                                   * particles(is)%weight_factor   &
-                                   * ( particles(is)%radius**3 )   &
-                                   / sl_r3 ) )                     &
-                                   / ( particles(is)%radius**3 )
-
-                      IF ( particles(is)%weight_factor < 0.0_wp )  THEN
-                         WRITE( message_string, * ) 'negative ',   &
-                                         'weighting factor: ',     &
-                                         particles(is)%weight_factor
-                         CALL message( 'lpm_droplet_collision', &
-                                       'PA0039',                &
-                                       2, 2, -1, 6, 1 )
-                      ENDIF
-                   ENDIF
-                ENDDO
-
-             ENDIF
-
-             particles(n)%radius = particles(n)%radius + delta_r
-             ql_vp(k,j,i) = ql_vp(k,j,i) +               &
-                            particles(n)%weight_factor * &
-                            ( particles(n)%radius**3 )
-          ENDDO
-
-          ql_vp(k,j,i) = ql_vp(k,j,i) + particles(psi)%weight_factor  &
-                                        * particles(psi)%radius**3
-
-       ENDIF  ! collision kernel
-
-    ELSE IF ( prt_count(k,j,i) == 1 )  THEN
-
-       psi = 1
-
-!
-!--    Calculate change of weighting factor due to self collision
-       IF ( ( hall_kernel  .OR.  wang_kernel )  .AND.  &
-            use_kernel_tables )  THEN
-
-          IF ( wang_kernel )  THEN
-             eclass = INT( diss(k,j,i) * 1.0E4_wp / 1000.0_wp * &
-                           dissipation_classes ) + 1
-             epsilon = diss(k,j,i)
-          ELSE
-             epsilon = 0.0_wp
           ENDIF
-          IF ( hall_kernel  .OR.  epsilon * 1.0E4_wp < 0.001_wp )  THEN
-             eclass = 0   ! Hall kernel is used
-          ELSE
-             eclass = MIN( dissipation_classes, eclass )
-          ENDIF
-
-          ddV = ddx * ddy / dz 
-          rclass_l = particles(psi)%class
-          sum3 = 1 - dt_3d * ddV *                                 &
-                     ( ckernel(rclass_l,rclass_l,eclass) *         &
-                       ( particles(psi)%weight_factor-1 ) * 0.5_wp )
-
-          particles(psi)%radius = ( particles(psi)%radius**3 / &
-                                    sum3 )**0.33333333333333_wp
-          particles(psi)%weight_factor = particles(psi)%weight_factor &
-                                         * sum3
-
-       ELSE IF ( ( hall_kernel  .OR.  wang_kernel )  .AND.  &
-                  .NOT. use_kernel_tables )  THEN
-!
-!--       Collision efficiencies are calculated for every new
-!--       grid box. First, allocate memory for kernel table.
-!--       Third dimension is 1, because table is re-calculated for
-!--       every new dissipation value.
-          ALLOCATE( ckernel(psi:psi, psi:psi, 1:1) )
-!
-!--       Now calculate collision efficiencies for this box
-          CALL recalculate_kernel( i, j, k )
-
-          ddV = ddx * ddy / dz 
-          sum3 = 1 - dt_3d * ddV * ( ckernel(psi,psi,1) *  &
-                       ( particles(psi)%weight_factor - 1 ) * 0.5_wp ) 
-
-          particles(psi)%radius = ( particles(psi)%radius**3 / &
-                                    sum3 )**0.33333333333333_wp
-          particles(psi)%weight_factor = particles(psi)%weight_factor &
-                                         * sum3
-
-          DEALLOCATE( ckernel )
-       ENDIF 
-
-      ql_vp(k,j,i) =  particles(psi)%weight_factor *              &
-                       particles(psi)%radius**3
+
+          particles(1:number_of_particles)%radius = ( mass(1:number_of_particles) /   &
+                                                      ( weight(1:number_of_particles) &
+                                                        * factor_volume_to_mass       &
+                                                      )                               &
+                                                    )**0.33333333333333_wp
+
+          particles(1:number_of_particles)%weight_factor = weight(1:number_of_particles)
+
+          DEALLOCATE( weight, mass, ckernel )
+
+       ENDIF
+ 
     ENDIF
-
-!
-!-- Check if condensation of LWC was conserved during collision process
+    
+
+!
+!-- Check if LWC is conserved during collision process
     IF ( ql_v(k,j,i) /= 0.0_wp )  THEN
-       IF ( ql_vp(k,j,i) / ql_v(k,j,i) >= 1.0001_wp  .OR.             &
+       IF ( ql_vp(k,j,i) / ql_v(k,j,i) >= 1.0001_wp  .OR.                      &
             ql_vp(k,j,i) / ql_v(k,j,i) <= 0.9999_wp )  THEN
-          WRITE( message_string, * ) 'LWC is not conserved during',&
-                                     ' collision! ',               &
-                                     'LWC after condensation: ',   &
-                                     ql_v(k,j,i),                  &
-                                     ' LWC after collision: ',     &
-                                     ql_vp(k,j,i)
-          CALL message( 'lpm_droplet_collision', 'PA0040',         &
-                        2, 2, -1, 6, 1 )
+          WRITE( message_string, * ) ' LWC is not conserved during',           &
+                                     ' collision! ',                           &
+                                     ' LWC after condensation: ', ql_v(k,j,i), &
+                                     ' LWC after collision: ', ql_vp(k,j,i)
+          CALL message( 'lpm_droplet_collision', 'PA0040', 2, 2, -1, 6, 1 )
        ENDIF
     ENDIF
Index: palm/trunk/SOURCE/lpm_droplet_condensation.f90
===================================================================
--- palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Unused variables removed.
 ! 
 ! Former revisions:
@@ -87,6 +87,6 @@
 
     USE cloud_parameters,                                                      &
-        ONLY:  bfactor, curvature_solution_effects, diff_coeff_l,              &
-               eps_ros, l_d_rv, l_v, rho_l,  r_v, thermal_conductivity_l
+        ONLY:  bfactor, curvature_solution_effects, eps_ros, l_d_rv, l_v,      &
+               rho_l,  r_v
 
     USE constants,                                                             &
@@ -94,11 +94,11 @@
 
     USE control_parameters,                                                    &
-        ONLY:  atmos_ocean_sign, dt_3d, dz, message_string,                    &
-               molecular_viscosity, rho_surface
+        ONLY:  dt_3d, dz, message_string, molecular_viscosity, rho_surface
+
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point_s
 
     USE grid_variables,                                                        &
-        ONLY:  dx, ddx, dy, ddy
+        ONLY:  dx, dy
 
     USE lpm_collision_kernels_mod,                                             &
@@ -109,6 +109,5 @@
     USE particle_attributes,                                                   &
         ONLY:  block_offset, grid_particles, hall_kernel, number_of_particles, &
-               offset_ocean_nzt, offset_ocean_nzt_m1, particles,               &
-               radius_classes, use_kernel_tables, wang_kernel
+               particles, radius_classes, use_kernel_tables, wang_kernel
 
 
